#!/usr/bin/perl
#$|=1;
use strict;
use File::Basename;
use Gtk2 '-init';
use Gtk2::SimpleList;
my $dirplay=$ARGV[0].'/DVD/';
my @apps=("vlc","totem");
my @player;
foreach my $player (@apps){
my $prog=`which $player`;
chomp $prog;
push @player,$prog
}

use DBI;
my $home=$ENV{'HOME'};
my $dbfile=$home.'/.burn_360.db';
my $dbh=DBI->connect("dbi:SQLite:dbname=$dbfile","","",{AutoCommit=>1});
my @tables=$dbh->tables;
unless (grep /spath/,@tables){
$dbh->do("create table spath(idp integer,searchpath PRIMARY KEY)");
$dbh->do("insert into spath (idp) VALUES (1)");

}
unless (grep /player/,@tables){
$dbh->do("create table splayer(idpl integer,program PRIMARY KEY, flags)");
$dbh->do("insert into splayer (idpl) VALUES (1)");
}
unless (grep /spath/,@tables){
$dbh->do("create table vpath(idd integer,plpath PRIMARY KEY)");
$dbh->do("insert into vpath (idd) VALUES (1)");
}


my $self=__FILE__;
my $extra='/bin/burn_360';
$self=~s/$extra.*//g;
my $prefix=$self;
my @dirs;
my @searchdirs=();

my $vbox=Gtk2::VBox->new(0,0);
my $dirs_vbox=Gtk2::VBox->new(0,0);
my $dir_hbox=Gtk2::HBox->new(0,0);
my $searchlabel=Gtk2::Label->new();
$searchlabel->set_alignment(0,0);
$dirs_vbox->pack_start($searchlabel,0,0,0);
my $mod_dir=Gtk2::Button->new("Search Directorys");
my $title_frame=Gtk2::Frame->new;
my $dirs_frame=Gtk2::Frame->new;
my $prog=Gtk2::ComboBox->new_text;
$prog->append_text('Choose Program');
foreach my $prog1 (@player){
$prog->append_text($prog1);
}
$prog->set_active(0);
$dirs_frame->add($dirs_vbox);
my $title=Gtk2::Label->new("List of Directories to search\nClick \"Add Search Directory\" button to add");
my $update_dvds=Gtk2::Button->new("Update\nDVD paths");


$title_frame->add($title);
$vbox->pack_start($title_frame,0,0,0);
	$mod_dir->signal_connect('clicked'=>sub{
	my %col=(
	0=>{col=>'idp',field=>'idp',type=>'int'},
	1=>{col=>'path',field=>'searchpath',type=>'text'},
	opts=>{updatesub=>'sdirs1'}
	);

	&modwin('spath',\%col);

	}
	);
my @sdirs=@{&sdirs1};

	sub sdirs1 {
	my $sql=$dbh->selectall_hashref("select * from spath",1);
	@sdirs='';
	#print "\nsdirs\n";

my @sdir;
	foreach my $search (sort keys %{$sql}){
	push @sdir,$sql->{$search}->{searchpath};
	}
	$searchlabel->set_text(join "\n",@sdir);
	return \@sdir;
	}

	sub modwin {
	my ($table,$colh)=@_;
	my %col=%{$colh};
	my $win=Gtk2::Window->new();
	my $label=Gtk2::Label->new('Modify Paths to search for DVD ');
	my $type='int';
	my %slist;
	my @slist;
	foreach my $key (sort  keys %col){
	push @slist,$col{$key}->{col},$col{$key}->{type} if $key=~/[0-9]/
	}

	my $list=Gtk2::SimpleList->new(
	@slist
	); 

	my $sql=$dbh->selectall_arrayref("select * from $table");
	my $reccount=scalar @{$sql};

	if ($reccount==0) {
	push @{$sql},1
	}
	#my @cols=($col1,$col2);
	;
	$list->set_data_array($sql);
	my $vbox=Gtk2::VBox->new(0,0);
	$vbox->pack_start($label,0,0,0);
	$vbox->pack_start($list,0,0,0);

	#foreach my $line (@{$list}){
	$list->set_column_editable(1,1);
	my ($hpath,$hfocus,$mod_id,$hrow_ref);

	$list->signal_connect('cursor_changed'=>sub{
				($hpath,$hfocus)= $list->get_cursor;
				$hrow_ref = $list->get_row_data_from_path ($hpath);
				$mod_id=$hrow_ref->[0];
				}
				);
		foreach my $col (keys %col){
			if ($col=~/[0-9]/){
			$list->set_column_editable($col,1);
			$list->get_column($col)->get_cell_renderers->signal_connect('edited'=>sub{
					my $val=$hrow_ref->[1];
					my $id=$hrow_ref->[0];
			$val=~s/\n//g;
					my $sql=$dbh->do("update $table set $col{$col}->{field} ='$val' where $col{0}->{field}=$id");

					}
					);
			}
		}

	$list->signal_connect('button-press-event'=>sub{
			my ($widget, $event) = @_;               
			return 0 unless $event->button == 3;
			my $action_menu=Gtk2::Menu->new;
			my $itemdel=Gtk2::MenuItem->new('Delete path');
			my $itemins=Gtk2::MenuItem->new('Add path');
			$action_menu->append($itemdel);
			$action_menu->append($itemins);
			$itemdel->show;
			$itemins->show;

					$action_menu->popup(
						undef, # parent menu shell
						undef, # parent menu item
						undef, # menu pos func
						undef, # data
						$event->button,
						$event->time);
				my ($path,$focus)= $list->get_cursor;
			my $row_ref = $list->get_row_data_from_path ($path);
			$itemdel->signal_connect('activate'=>sub{
			$dbh->do("delete from spath where idp=$row_ref->[0]");
			my @index= $list->get_selected_indices;
			no strict 'refs';
			splice @{$list->{data}},$index[0],1 ;
			}
			);
			$itemins->signal_connect('activate'=>sub{
	my $search_dir=&selection("add_directory to Search","select-folder");
	if ($reccount==0){$dbh->do("insert into $table  VALUES(1,'$search_dir')");
	} 
	else {
	$dbh->do("insert into spath select max(cast (idp as integer))+1,'$search_dir' from $table");
	}
	$reccount++;

	my $idnew=$dbh->selectcol_arrayref("select max(cast (idp as integer)) from $table")->[0];
			my @index= $list->get_selected_indices;
			no strict 'refs';
			push @{$list->{data}},[$idnew,$search_dir] ;
			}
	);
	}
	);

	$win->add($vbox);
	$win->signal_connect('delete_event' => sub { 
	no strict 'refs';
	&{$col{opts}->{updatesub}};
	$win->destroy();
	}
	);
	$win->show_all;




	}






$dir_hbox->pack_start($dirs_frame,1,1,0);
$dir_hbox->pack_start($mod_dir,0,0,0);
$dir_hbox->pack_start($prog,0,0,0);
$vbox->pack_start($dir_hbox,0,0,0);
my $dir=Gtk2::ComboBox->new_text;

my @dirsl;
$update_dvds->signal_connect('clicked'=>sub{
$dbh->do("delete from vpath");
my $count=1;
my @dirn;

	foreach my $list (@sdirs){
	my @dirsfind=`find $list -xdev -iname  'VIDEO_TS' -type d`;
		foreach my $path (@dirsfind){print $path,"\n";
chomp $path;
		$dbh->do("insert into vpath VALUES ('$count','$path')");
		$count++
		}
	}
&show_dvds;
}
);
my %drives;
&show_dvds;
sub show_dvds {
my @dvds=@{$dbh->selectcol_arrayref("select plpath from vpath order by plpath")};
print @dvds;

$dir->get_model->clear;
%drives=%{&disks};
if($dirplay){
$dir->append_text($dirplay);
}
else {
$dir->append_text('Choose DVD file system');
	foreach my $keys (keys %drives){
	$dir->append_text($drives{$keys}->{label}) if $drives{$keys}->{type}=~/udf/;
	}
foreach my $keys (@dvds){
	$dir->append_text($keys);
	}
}

}





if (length($dirplay)>1){
$dir->append_text($dirplay);
$dir->set_active(1);
}
else {
$dir->set_active(0);
my @DVD;
foreach my $dirs (sort @dirs)
{if ($dirs=~/VIDEO_TS$/){
chomp $dirs;
$dirs=~s/DVD\/VIDEO_TS//;
$dir->append_text("$dirs")
}
};

}
my $button=Gtk2::Button->new('View DVD');
my $box=Gtk2::HBox->new(0,0);
$button->signal_connect('clicked'=>sub{
my $dvd=$dir->get_active_text;
my $program=$prog->get_active_text;
chomp $program;
chomp $dvd;
my $cmd;
foreach my $disc (keys %drives){
$dvd=$disc if $drives{$disc}->{label} eq $dir->get_active_text;
}

if ($program=~/vlc|totem/){
$cmd="$program $dvd";
print "\n",$cmd,"\n";
}
else {
$cmd="$program dvd:\/\/ -dvd-device \"$dvd\""
}

system("$cmd");

});

my $window=Gtk2::Window->new('toplevel');
$window->set_default_icon_from_file("/usr/share/burn_360/icons/burn_360.png");
$window->set_title("Play DVD Dir");
$window->set_default_size(480,200);
$window -> signal_connect ('delete_event' => sub { Gtk2->main_quit;});
$vbox->pack_start($mod_dir,1,1,10);
$box->pack_start($dir,1,1,10);
$box->pack_start($update_dvds,1,1,10);
$box->pack_start($button,0,0,10);
$vbox->pack_start($box,1,0,10);
$window->add($vbox);
$window->show_all();
Gtk2->main();
0;



sub selection {
my ($heading,$type) = @_;
my $file_chooser =Gtk2::FileChooserDialog->new (
$heading,undef,$type,'gtk-cancel' => 'cancel','gtk-ok' => 'ok'
);
$file_chooser->set_select_multiple('FALSE') ;
my $dirname;
if ('ok' eq $file_chooser->run){$dirname = $file_chooser-> get_filenames};

$file_chooser->destroy;
return $dirname;
}

sub disks {
my @dev=`udisks --enumerate`;
foreach my $line (@dev){
chomp $line;
my @arr=split/\//,$line;
$line='/dev/'.$arr[$#arr];
}

my %drives;
foreach my $dev (@dev){
my @list=`udisks --show-info $dev`;
my %init_hash;
foreach my $line (@list){
chomp $line;
my @line2=split /:/,$line;
$line2[0]=~s/^\s+//;
$line2[1]=~s/^\s+//;
$init_hash{$line2[0]}=$line2[1];
}
$drives{$dev}={};
foreach my $keys (keys %init_hash){
$drives{$dev}->{$keys}=$init_hash{$keys}
}
}

my %diskschk;
my %mounts;

	foreach my $drive (keys %drives){

	if ($drives{$drive}->{blank}!~/1/){
$drives{$drive}->{name}=$drives{$drive}->{label};
		if ($drives{$drive}->{type}=~/udf/) {
		$drives{$drive}->{disc}='DVD';
		}
		if ($drives{$drive}->{type}=~/iso9660/){
			if (-e glob($drives{$drive}->{mount}.'/mpegav')){
			$drives{$drive}->{disc}='VCD' ;
			}

		}
	}
	else { 
		if ($drives{$drive}->{media} =~/dvd/i){
		$drives{$drive}->{disc}='dvdw';
		}
		elsif ($drives{$drive}->{media} =~/cd/i){
		$drives{$drive}->{disc}='cdw'
		}
	}

	}
no strict 'refs';

return \%drives
#}
}




